Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.core
Interface GuiIfc

All Superinterfaces:
  GpsDataListener, ShutdownHandler

All Known Implementing Classes:
  MainFrame

    public interface GuiIfc

extends ShutdownHandler, GpsDataListener

This provides a GUI subsystem independent interface to the UI, so the backend can request GUI services without having to worry about whether it is AWT/Swing or something else (such as Android).

Note that any implementer of this interface is also required to:

1. provide a no-argument constructor, and
2. provide a static method with the signature: `public static Object showSplashScreen()` which creates a start-up splash screen and returns a handle to it so it can be taken down later with the disposeOfSplash(Object) method on the GuiIfc implementer.

Nested Class Summary
`static class` | `GuiIfc.MessagingParams` Data structure containing parameters needed to transmit a text message.
`static class` | `GuiIfc.OsmImportParams` Data structure of parameters needed for the OpenStreetMap import operation.
`static class` | `GuiIfc.TileDownloadParams` Data structure of parameters needed for the OpenStreetMap pre-imported tile download operation.

Method Summary
`void` | `addSpecificTrackStripe(java.lang.String identifier)` Add the identifier of a single station or object whose track stripe is to be plotted.
`void` | `approveTacticalSender(java.lang.String originatingCallsign, java.lang.String tacticalMsgText)` Queue up a request to ask the user whether this TACTICAL message should be accepted and processed.
`void` | `checkForUpdates(boolean interactive)` Check whether a newer release of YAAC is available, displaying status.
`void` | `clearAllSpecificTrackStripes()` Clear the plotting of all specific station/object track stripes.
`void` | `closeCurrentWindow()` Close the window that currently has the keyboard focus (if it is part of the YAAC application).
`void` | `composeWinlinkMessage()` Display a form to allow transmitting a multi-line email message to someone via the APRS-WinLink gateways.
`void` | `confirmSendBroadcastQuery(java.lang.String confirmTag, java.lang.String query)` Broadcast a specified global query message after confirming the user really wants to send it.
`void` | `connectToStation()` Set up a dumb-terminal connection to an old-style packet BBS.
`StatusListener` | `createProgressReporter(java.lang.String title, boolean modal)` Open whatever the local operating system uses for a progress dialog and return an interface to send progress information to the dialog.
`void` | `displayAttentionAlert(double latitude, double longitude, AX25Message.Precedence precedence)` Display an AttentionAlert (flashing arrows) on the map for a particular position.
`void` | `displayAttentionAlert(StationState ss)` Display an AttentionAlert (flashing arrows) on the map for a particular station or object.
`java.lang.Object[]` | `displayHeardByDialog(StationState[] stationsToPickFrom)` Display a dialog asking for the parameters for a Heard-By (?APRSH) query.
`void` | `displayHelp(java.lang.String startingHelpId, java.lang.Object parentWindow)` Launch the JavaHelp browser, starting with the help corresponding to the specified help ID
`void` | `displayLocateAmenityDialog()` Display the Locate Amenity dialog, and handle user input to it.
`void` | `displayLocateLandmarkDialog()` Display the Locate Landmark dialog, and handle user input to it.
`GuiIfc.MessagingParams` | `displayMessagingDialog(java.util.ArrayList ssList)` Display a dialog asking the user for the parameters needed to send a text message to another station.
`GuiIfc.OsmImportParams` | `displayOsmImportDialog(java.io.File osmFileDir)` Ask the user how and where from to import an OpenStreetMap compressed data file.
`void` | `displayOsmMirrorSiteList()` Display a popup with buttons to launch the user's web browser pointed at any of the major download sites for raw OpenStreetMap data.
`GuiIfc.TileDownloadParams` | `displayOsmTileDownloadDialog(ChangeSet localChangeSet, ChangeSet serverChangeSet)` Display a dialog asking the user which pre-compiled OSM tiles to download.
`GuiIfc.TileDownloadParams` | `displayTopoTileDownloadDialog(java.io.File tileDir)` Display a dialog asking the user which SRTM tiles to download.
`void` | `disposeOfSplash(java.lang.Object oSplash)` Get rid of the splash screen.
`void` | `editTopoColors()` Invoke an editor for adjusting the colors and elevation thresholds used to render topographic map layers.
`boolean` | `ensureKeystoreIsOpen(boolean dontBlock)` Test if keystore has been opened with the correct password.
`double` | `getCenterLatitude()` Get the latitude of the current center of the map.
`double` | `getCenterLongitude()` Get the longitude of the current center of the map.
`long` | `getLastElapsedPaintTime()` Return the amount of time (in milliseconds) for the last station render.
`int` | `getLastNumDrawnObjects()` Return the number of Objects (non-transmitters) rendered in the last station render.
`int` | `getLastNumDrawnStations()` Return the number of stations (transmitters) rendered in the last station render.
`long` | `getMaxAgeDRObject()` Get the maximum time that dead reckoning will be projected for an object (non-self-transmitter).
`long` | `getMaxAgeDRSpecialObject()`
`long` | `getMaxAgeDRStation()` Get the maximum time that dead reckoning will be projected for a station (self-transmitter).
`long` | `getMaxTrackDuration()` Get the maximum duration of a track stripe in milliseconds.
`int` | `getMessageCount()` Get the number of APRS Messages collected by the application.
`SaveableTable` | `getSaveableTableInView(java.lang.Object view)` Get the SaveableTable (if any) in the specified view.
`float` | `getScale()` Get the current scale factor of the map.
`void` | `initializeWindowMenu(java.lang.Object item, java.lang.Object view)` Create the entries on the dynamic Window menu on the menu bar corresponding to every window except the one containing the menu bar.
`void` | `initMainWindowMenuBar()` Phase 2 of initializing the GUI (stuff that needs the GUI property of the main YAAC object to be already initialized).
`void` | `invokeConfigWizard()` Start the configuration wizard at its first window.
`void` | `invokeObjectEditor(java.lang.String dialogTitleTag, Message or, int mouseX, int mouseY, ObjectReportTransmitter tx)` Display the Object editing dialog, possibly initialized with the contents of an existing ObjectReport.
`boolean` | `isAutoLoadMapTiles()` Report whether map tiles will be auto-downloaded (if the author's website can be reached) for any tiles that have not already been downloaded.
`boolean` | `isDrawAge()` Report whether the time interval since last receipt of a message from or about a station or object is plotted below the station/object's name.
`boolean` | `isDrawAliasInsteadOfCallsign()` Report whether alias should be drawn instead of callsign should be drawn for each station/object if an alias is defined for the station/object..
`boolean` | `isDrawAllTrackStripes()` Indicate whether all moving stations should have track stripes plotted.
`boolean` | `isDrawAlohaCircle()` Report whether aloha circles (optimal maximum RF transmission range for the local station before causing excessive collisions) are plotted on the map.
`boolean` | `isDrawAmbiguityCircle()` Report whether a translucent ambiguity circle is drawn behind each station or object to indicate the area over which it could be located, given the precision of the position information reported.
`boolean` | `isDrawCallsign()` Report whether callsign label should be drawn for each station/object.
`boolean` | `isDrawDeadObjects()` Report whether Objects that have been "killed" are plotted on the map.
`boolean` | `isDrawDeadReckoning()` Report whether deadreckoning position updates for moving stations and objects are calculated and the positions offset and deadreckoning vectors plotted when the stations and objecfts are drawn.
`boolean` | `isDrawDF()` Report whether direction-finding cones are plotted from stations reporting DFS vector information
`boolean` | `isDrawDoubleSizedSymbols()` Report if symbols are being drawn double-sized.
`boolean` | `isDrawItemStatus()` Report whether a color-coded "halo" is drawn around each station or object icon indicating its status as one of the APRSdos categories: fixed, mobile, deadreckoned, old, emergency-reporting, locally-controlled Object, or other station's Object.
`boolean` | `isDrawMicEStatusCircles()` Report whether color-coded circles indicating Mic-E status codes are be drawn around stations reporting those codes.
`boolean` | `isDrawNWSMultiLine()` Report whether encoded polylines (generally used for National Weather Service severe weather regions) are plotted on the map.
`boolean` | `isDrawRangeCircles()` Report whether radio range circles are being drawn for stations reporting or implying transmission range limits.
`boolean` | `isDrawSelf()` Report whether the local station is plotted on the map.
`boolean` | `isDrawSelfLikeOther()` Report whether local station is drawn like any other station (using its APRS symbol icon) or as crosshairs or a pointer making it obvious where the station is on the map.
`boolean` | `isDrawWeatherAsWeather()` Report whether weather stations are drawn as old-style weather map circles with a flagged barb indicating wind direction and speed.
`boolean` | `isGraticuleVisible()` Indicate whether the graticule (latitude/longitude grid lines) are displayed on the map.
`boolean` | `isKeepSpecificallyTrackedStationsOnScreen()` Report whether the map should auto-pan to keep specifically tracked mobile stations on the map.
`boolean` | `isMapAutoCentered()` Report whether the map should automatically pan to keep the local station centered on the map.
`boolean` | `isMemoryGCPanelVisible()` Report the current visibility of the MemoryGCPanel.
`boolean` | `isNightMode()` Report if the displays are in night mode.
`boolean` | `isShowLabelsInEnglish()` Report whether map labels should be displayed in English if the default name is in some other locale and OpenStreetMap provides an English translation.
`boolean` | `isShowTopoContours()` Report whether the topographic map should be rendered as contour lines.
`boolean` | `isShowTopoRegions()` Report whether the topographic map overlay should be displayed as filled regions.
`boolean` | `isShowUnlabeledWays()` Report if unlabeled and untyped map features should be displayed.
`boolean` | `isSpecificallyTracked(java.lang.String identifier)` Test if a given identifier is on the tracking list.
`boolean` | `isSpecificallyTracking()` Test if any identifiers are on the tracking list.
`boolean` | `isViewPrintable(java.lang.Object o, int depthLeft)` Test if specified GUI view is printable.
`void` | `loadAprsPackets()` Query the user for a file from which to load saved APRS messages.
`void` | `loadDrawing()` Load drawing overlay.
`void` | `loadObjectsFromFile()` Load APRS Object definitions from a user-specified file.
`void` | `loadTacticalNames()` Load alias names and symbol codes for station callsigns and object names.
`void` | `locateASpecificStation(java.util.ArrayList<StationState> matchList, java.lang.String callsign)` Locate a specific station on the map window.
`void` | `moveObject(StationState ss, ObjectReport or, MoveObjectListener moveObjectListener)` Graphically drag a station or object across the map to a new location, updating the object's position appropriately and converting a station to an object if needed.
`StationState` | `pickAStation(java.util.ArrayList<StationState> matchList, java.lang.String titleTag)` Select one of several stations.
`void` | `printWindow()` Print the window that currently has the focus.
`void` | `refresh()` Force the map to immediately regenerate itself based on current state data.
`void` | `regenerateStations()` Force the station renderer layer to regenerate its overlay immediately.
`void` | `regenerateTopo()` Force the topographic layer to regenerate its overlay immediately.
`boolean` | `removeSpecificTrackStripe(java.lang.String identifier)` Remove the identifier of a single station or object whose track stripe is no longer to be plotted.
`void` | `saveAprsPackets()` Query the user for a file in which to save the current visible set of APRS messages.
`void` | `saveObjectsToFile()` Save the currently known APRS Objects to a file.
`void` | `saveTacticalNames()` Save alias names and symbol codes for station callsigns and object names.
`void` | `scheduleToGuiThread(java.lang.Runnable r)` Schedule a short-running operation that should only occur on the GUI dispatch thread (however the implementing GUI chooses to do it).
`java.io.File` | `selectFileForWrite(java.io.File dir, java.lang.String fileExtensionTag, java.lang.String fileExtension)` Open a file selection dialog for saving a file.
`int` | `selectOneOf(java.lang.String title, java.lang.String[] choices)` Create a popup dialog to ask the user which of several choices should be used.
`java.lang.Object` | `selectStation(java.lang.String titleBarTag, boolean stationsOnly)` Select one station (or object, if allowed) from the currently known list, or allow the user to manually type in a station callsign-SSID, and return the user selected value.
`void` | `sendQRU()` Broadcast a specified QRU query message after confirming the user really wants to send it.
`void` | `setAutoLoadMapTiles(boolean autoLoadMapTiles)` Specify whether missing OpenStreetMap imported tiles should be automatically downloaded from the author's website.
`void` | `setCenter(double lat, double lon)` Set the current center position of the map.
`void` | `setCenter(LatLonPoint p)` Set the current center position of the map.
`void` | `setDrawAge(boolean drawAge)` Specify whether the time interval since last receipt of a message from or about a station or object should be plotted below the station/object's name.
`void` | `setDrawAliasInsteadOfCallsign(boolean drawAliasInsteadOfCallsign)` Specify whether alias should be drawn instead of callsign should be drawn for each station/object if an alias is defined for the station/object..
`void` | `setDrawAllTrackStripes(boolean drawAllTrackStripes)` Specify whether all moving stations should have track stripes plotted.
`void` | `setDrawAlohaCircle(boolean drawAlohaCircle)` Specify whether aloha circles (optimal maximum RF transmission range for the local station before causing excessive collisions) should be plotted on the map.
`void` | `setDrawAmbiguityCircle(boolean drawAmbiguityCircle)` Specify whether a translucent ambiguity circle should be drawn behind each station or object to indicate the area over which it could be located, given the precision of the position information reported.
`void` | `setDrawCallsign(boolean drawCallsign)` Specify whether callsign labels should be drawn for each station/object.
`void` | `setDrawDeadObjects(boolean drawDeadObjects)` Specify whether Objects that have been "killed" should still be plotted on the map.
`void` | `setDrawDeadReckoning(boolean drawDeadReckoning)` Specify whether deadreckoning position updates for moving stations and objects should be calculated and the positions offset and deadreckoning vectors plotted when the stations and objecfts are drawn.
`void` | `setDrawDF(boolean drawDF)` Specify whether direction-finding cones should be plotted from stations reporting DFS vector information
`void` | `setDrawDoubleSizedSymbols(boolean drawDoubleSizedSymbols)` Specify whether symbols should be drawn double-sized (32x32 pixels) instead of single-sized (16x16).
`void` | `setDrawItemStatus(boolean drawItemStatus)` Specify whether a color-coded "halo" should be drawn around each station or object icon indicating its status as one of the APRSdos categories: fixed, mobile, deadreckoned, old, emergency-reporting, locally-controlled Object, or other station's Object.
`void` | `setDrawMicEStatusCircles(boolean drawMicEStatusCircles)` Specify whether color-coded circles indicating Mic-E status codes should be drawn around stations reporting those codes.
`void` | `setDrawNWSMultiLine(boolean drawNWSMultiLine)` Specify whether encoded polylines (generally used for National Weather Service severe weather regions) should be plotted on the map.
`void` | `setDrawRangeCircles(boolean drawRangeCircles)` Specify whether range circles should be drawn around stations reporting or implying transmission range limits.
`void` | `setDrawSelf(boolean drawSelf)` Specify whether the local station should be plotted on the map.
`void` | `setDrawSelfLikeOther(boolean drawSelfLikeOther)` Specify whether local station should be drawn like any other station (using its APRS symbol icon) or as crosshairs or a pointer making it obvious where the station is on the map.
`void` | `setDrawToolBarVisibility(boolean isVisible)` Specify whether the toolbar for the drawing tools should be visible or not.
`void` | `setDrawWeatherAsWeather(boolean drawWeatherAsWeather)` Specify whether weather stations should be drawn as old-style weather map circles with a flagged barb indicating wind direction and speed.
`void` | `setGraticuleVisible(boolean visible)` Specify whether the graticule (latitude/longitude grid lines) are displayed on the map.
`void` | `setKeepSpecificallyTrackedStationsOnScreen(boolean keepSpecificallyTrackedStationsOnScreen)` Specify whether the map should auto-pan to keep specifically tracked mobile stations on the map.
`void` | `setMainFrameTitle()` Specify the title displayed in the main window's title bar.
`void` | `setMapAutoCentering(boolean isAutoCentered)` Specify whether the map should automatically pan to keep the local station centered on the map.
`void` | `setMaxAgeDRObject(long maxAgeDRObject)` Set the maximum time that dead reckoning will be projected for an object (non-self-transmitter).
`void` | `setMaxAgeDRSpecialObject(long maxAgeDRSpecialObject)`
`void` | `setMaxAgeDRStation(long maxAgeDRStation)` Set the maximum time that dead reckoning will be projected for a station (self-transmitter).
`void` | `setMaxTrackDuration(long maxTrackDuration)` Set the maximum duration of a track stripe in milliseconds.
`void` | `setMemoryGCPanelVisible(boolean visible)` Change the visibility of the memory usage status monitor.
`void` | `setNightMode(boolean isNight)` Specify that the displays should be in night mode (black backgrounds with white text/lines, for not ruining the night vision of the operator).
`void` | `setScale(float scale)` Change the scale of the map.
`void` | `setShowLabelsInEnglish(boolean showLabelsInEnglish)` Specify whether map labels should be displayed in English if the default name is in some other locale and OpenStreetMap provides an English translation.
`void` | `setShowTopoContours(boolean visible)` Specify whether the topographic map overlay should be rendered as contour lines.
`void` | `setShowTopoRegions(boolean visible)` Specify whether the topographic map overlay should be rendered as filled region.
`void` | `setShowUnlabeledWays(boolean showUnlabeledWays)` Specify if unlabeled and untyped map features should be displayed.
`void` | `setVisible(boolean visible)` Specify whether the main (map) display window should be visible.
`void` | `showAboutDialog()` Display the About dialog for the YAAC application.
`void` | `showBandwidthMonitor()` Display a bandwidth monitor for each open I/O port in YAAC.
`void` | `showBulletinBoard()` Display the window used to display bulletin messages, and compose locally originated bulletins for transmission.
`void` | `showConfigurationDialog()` Start the regular configuration dialog.
`void` | `showConnectionReport()` Display outstanding connected (I-frame) AX.25 sessions.
`void` | `showDXReports()` Show a table view of all DX reports received by this station.
`void` | `showEditBlacklistDialog()` Generate and display the blacklist editor.
`void` | `showEditFilterDialog(Filter mainFilter, java.lang.String dialogTitleTag)` Generate and display the filter dialog.
`int` | `showGenericConfirmDialog(java.lang.String titleTag, java.lang.String msg)` Show a generic retry/skip/cancel dialog, with the specified title and message text.
`void` | `showGenericErrorDialog(java.lang.String titleTag, java.lang.String msg)` Show a generic error message dialog, with the specified title and message text.
`void` | `showGenericInfoDialog(java.lang.String titleTag, java.lang.String msg)` Show a generic informational message dialog, with the specified title and message text.
`java.lang.String` | `showGenericInputDialog(java.lang.String titleTag, java.lang.String msg)` Show a generic text input dialog, with the specified title and message text.
`int` | `showGenericQuestionDialog(java.lang.String titleTag, java.lang.String msg)` Show a generic yes/no question dialog, with the specified title and message text.
`int` | `showGenericQuestionDialogWithHelp(java.lang.String titleTag, java.lang.String msg)` Show a generic yes/no question dialog, with the specified title and message text.
`void` | `showGpsStatusDialog()` Display a monitor of the current status of all GPS receivers connected to YAAC.
`void` | `showHealthMonitorReport()` Show the current station health reports for all remote stations being monitored.
`void` | `showHeardList()` Display a report of number of packets received from each station (or about each APRS Object/Item) over 15 minute intervals in the YAAC history.
`void` | `showHistory(StationState ss)` Display the message history for a specified station or object.
`void` | `showIOFailureDialog(PortConfig config, java.lang.String reason, PortFailureReportListener listener)` Display an asynchronous non-blocking dialog on the screen to report an I/O error.
`void` | `showKeys()` Show a table view of the keys used to authenticate and verify the integrity of signed messages.
`void` | `showLayerSelectorTool()` Display the dialog for selecting which parts of the OpenStreetMap database should be rendered on the map.
`void` | `showLocalObjects()` Display a table of all Objects/Items being transmitted by this station.
`void` | `showMap()` Make visible and foreground the map window.
`void` | `showMessageFilterPane()` Display the window used for receiving and logging filtered text messages.
`void` | `showMessageFrame()` Open the MessageFrame (window displaying text message traffic in a table) and move it to the foreground.
`void` | `showOutstandingMessages()` Display the window showing all messages (except beacons and status messages) pending for transmission from the local station.
`void` | `showPluginStore()` Display a dialog for selecting new officially supported plugins to install.
`void` | `showRadioView(Message msg, java.lang.String identifier)` Show the dialog that looks like the Kenwood D710 control head APRS display.
`void` | `showRasterMapDialog()` Display the dialog for managing raster map images overlays on the map window.
`void` | `showRawPacketFrame()` Display the raw packet window.
`void` | `showReleaseNotes()` Display the release notes history for the YAAC application.
`void` | `showStationList()` Show the window listing all the stations and objects heard by this station.
`void` | `showTelemetryReport()` Display all the current telemetry data heard by this station.
`void` | `showTXIGatedStations()` Show a table view of the stations currently being Tx I-gated by this station.
`void` | `showWeatherDialog()` Display a monitor of the current conditions reported by the local weather station attached to YAAC.
`void` | `shutdown()` Do whatever cleanup this object needs for program shutdown.
`void` | `startChatSession(java.lang.String callsign)` Open a Chat session window pointed at the specified remote station.
`void` | `startLineOfSight()` Enable defining a line of sight between two points on the map.
`void` | `startLineOfSightFromMe(int mouseX, int mouseY)` Show the line of sight between this station's position and the position clicked on the map, updating this station's end of the line if it moves.
`void` | `startLineOfSightFromMe(StationState ss)` Show the line of sight between this station's position and the station or object clicked on the map, updating both ends of the line if either moves.
`void` | `toFront()` Push the map GUI window to the foreground by whatever means the underlying GUI toolkit uses.

Methods inherited from interface org.ka2ddo.yaac.gps.GpsDataListener
`gpsDataUpdated, satDataUpdated`

Method Detail

### setMainFrameTitle

    void setMainFrameTitle()

  Specify the title displayed in the main window's title bar.

### setVisible

    void setVisible(boolean visible)

  Specify whether the main (map) display window should be visible.

  Parameters:
    `visible` - boolean true if map window should be visible, false if not

### disposeOfSplash

    void disposeOfSplash(java.lang.Object oSplash)

  Get rid of the splash screen.

  Parameters:
    `oSplash` - Object wrapped around the splash screen

### initMainWindowMenuBar

    void initMainWindowMenuBar()

  Phase 2 of initializing the GUI (stuff that needs the GUI property of the main YAAC object to be already initialized).

### getMessageCount

    int getMessageCount()

  Get the number of APRS Messages collected by the application.

  Returns:
    message count

### invokeConfigWizard

    void invokeConfigWizard()

  Start the configuration wizard at its first window.

### showConfigurationDialog

    void showConfigurationDialog()

  Start the regular configuration dialog.

### isMapAutoCentered

    boolean isMapAutoCentered()

  Report whether the map should automatically pan to keep the local station centered on the map.

  Returns:
    boolean true if map should auto-center, false otherwise

### setMapAutoCentering

    void setMapAutoCentering(boolean isAutoCentered)

  Specify whether the map should automatically pan to keep the local station centered on the map.

  Parameters:
    `isAutoCentered` - boolean true if map should auto-center, false otherwise

### setScale

    void setScale(float scale)

  Change the scale of the map.

  Parameters:
    `scale` - new scaling factor

### getScale

    float getScale()

  Get the current scale factor of the map.

  Returns:
    scaling factor

### setCenter

    void setCenter(double lat,
                   double lon)

  Set the current center position of the map.

  Parameters:
    `lat` - latitude in degrees North
    `lon` - longitude in degrees East

### setCenter

    void setCenter(LatLonPoint p)

  Set the current center position of the map.

  Parameters:
    `p` - LatLonPoint for new center

### getCenterLatitude

    double getCenterLatitude()

  Get the latitude of the current center of the map.

  Returns:
    map center latitude in fractional degrees North

### getCenterLongitude

    double getCenterLongitude()

  Get the longitude of the current center of the map.

  Returns:
    map center longitude in fractional degrees East

### setNightMode

    void setNightMode(boolean isNight)

  Specify that the displays should be in night mode (black backgrounds with white text/lines, for not ruining the night vision of the operator).

  Parameters:
    `isNight` - boolean true if should be in night mode

### isNightMode

    boolean isNightMode()

  Report if the displays are in night mode.

  Returns:
    boolean true if in night mode

### shutdown

    void shutdown()

  Do whatever cleanup this object needs for program shutdown.

  Specified by:
    `shutdown` in interface `ShutdownHandler`

### createProgressReporter

    StatusListener createProgressReporter(java.lang.String title,
                                          boolean modal)

  Open whatever the local operating system uses for a progress dialog and return an interface to send progress information to the dialog.

  Parameters:
    `title` - already-localized title String for the dialog
    `modal` - whether the dialog should be application-modal or modeless
  Returns:
    StatusListener to use for sending progress reports to the dialog

### initializeWindowMenu

    void initializeWindowMenu(java.lang.Object item,
                              java.lang.Object view)

  Create the entries on the dynamic Window menu on the menu bar corresponding to every window except the one containing the menu bar.

  Parameters:
    `item` - Object corresponding to the Window menu
    `view` - GUI window object containing the menu bar

### showLayerSelectorTool

    void showLayerSelectorTool()

  Display the dialog for selecting which parts of the OpenStreetMap database should be rendered on the map.

### showGenericErrorDialog

    void showGenericErrorDialog(java.lang.String titleTag,
                                java.lang.String msg)

  Show a generic error message dialog, with the specified title and message text.

  Parameters:
    `titleTag` - String tag to look up locale-specific dialog title
    `msg` - already-localized and variable-substituted error message text String

### showGenericInfoDialog

    void showGenericInfoDialog(java.lang.String titleTag,
                               java.lang.String msg)

  Show a generic informational message dialog, with the specified title and message text.

  Parameters:
    `titleTag` - String tag to look up locale-specific dialog title
    `msg` - already-localized and variable-substituted error message text String

### showGenericQuestionDialog

    int showGenericQuestionDialog(java.lang.String titleTag,
                                  java.lang.String msg)

  Show a generic yes/no question dialog, with the specified title and message text.

  Parameters:
    `titleTag` - String tag to look up locale-specific dialog title
    `msg` - already-localized and variable-substituted error message text String
  Returns:
    0 for Yes, 1 for No, -1 for dialog closed without an explicit answer

### showGenericQuestionDialogWithHelp

    int showGenericQuestionDialogWithHelp(java.lang.String titleTag,
                                          java.lang.String msg)

  Show a generic yes/no question dialog, with the specified title and message text.

  Parameters:
    `titleTag` - String tag to look up locale-specific dialog title
    `msg` - already-localized and variable-substituted error message text String
  Returns:
    0 for Yes, 1 for No, 2 for Help, -1 for dialog closed without an explicit answer

### showGenericInputDialog

    java.lang.String showGenericInputDialog(java.lang.String titleTag,
                                            java.lang.String msg)

  Show a generic text input dialog, with the specified title and message text.

  Parameters:
    `titleTag` - String tag to look up locale-specific dialog title
    `msg` - already-localized and variable-substituted error message text String
  Returns:
    String text entered by user, or null to indicate dialog was closed without text entry

### showGenericConfirmDialog

    int showGenericConfirmDialog(java.lang.String titleTag,
                                 java.lang.String msg)

  Show a generic retry/skip/cancel dialog, with the specified title and message text.

  Parameters:
    `titleTag` - String tag to look up locale-specific dialog title
    `msg` - already-localized and variable-substituted error message text String
  Returns:
    0 for Retry, 1 for Skip, 2 for Cancel, -1 for dialog closed without an explicit answer

### showAboutDialog

    void showAboutDialog()

  Display the About dialog for the YAAC application.

### showReleaseNotes

    void showReleaseNotes()

  Display the release notes history for the YAAC application.

### ensureKeystoreIsOpen

    boolean ensureKeystoreIsOpen(boolean dontBlock)

  Test if keystore has been opened with the correct password. If it hasn't, prompt the user for the password so the keystore can be opened,

  Parameters:
    `dontBlock` - boolean true if this method should return immediately without blocking
  Returns:
    boolean true if the keystore is now open

### selectStation

    java.lang.Object selectStation(java.lang.String titleBarTag,
                                   boolean stationsOnly)

  Select one station (or object, if allowed) from the currently known list, or allow the user to manually type in a station callsign-SSID, and return the user selected value.

  Parameters:
    `titleBarTag` - String tag for localized title to display in popup dialog
    `stationsOnly` - boolean true if entries appearing only as Objects/Items should be excluded from the pick list
  Returns:
    String if user manually entered, StationState if selected from the pick list, or null if user cancelled the operation

### selectOneOf

    int selectOneOf(java.lang.String title,
                    java.lang.String[] choices)

  Create a popup dialog to ask the user which of several choices should be used.

  Parameters:
    `title` - String title to display in dialog box title
    `choices` - array of String choices to choose from
  Returns:
    index of selected choice, or -1 if the dialog was cancelled without selecting a choice

### loadAprsPackets

    void loadAprsPackets()

  Query the user for a file from which to load saved APRS messages.

### saveAprsPackets

    void saveAprsPackets()

  Query the user for a file in which to save the current visible set of APRS messages.

### getSaveableTableInView

    SaveableTable getSaveableTableInView(java.lang.Object view)

  Get the SaveableTable (if any) in the specified view.

  Parameters:
    `view` - top-level window or view to be tested
  Returns:
    SaveableTable object in the view, or null if there isn't a SaveableTable in the view

### showMap

    void showMap()

  Make visible and foreground the map window.

### displayOsmMirrorSiteList

    void displayOsmMirrorSiteList()

  Display a popup with buttons to launch the user's web browser pointed at any of the major download sites for raw OpenStreetMap data.

### displayOsmImportDialog

    GuiIfc.OsmImportParams displayOsmImportDialog(java.io.File osmFileDir)

  Ask the user how and where from to import an OpenStreetMap compressed data file.

  Parameters:
    `osmFileDir` - File pointing at the directory to initially look for importable OSM data files
  Returns:
    null if user cancelled the request, or an OsmImportParams object containing the import parameters

### displayOsmTileDownloadDialog

    GuiIfc.TileDownloadParams displayOsmTileDownloadDialog(ChangeSet localChangeSet,
                                                           ChangeSet serverChangeSet)

  Display a dialog asking the user which pre-compiled OSM tiles to download.

  Parameters:
    `localChangeSet` - the OSM ChangeSet of the last data downloaded or imported here (or null if OSM data was never installed)
    `serverChangeSet` - the OSM ChangeSet currently available on the YAAC website
  Returns:
    null if the user cancelled the request, or a TileDownloadParams structure containing the needed parameters for the download

### displayTopoTileDownloadDialog

    GuiIfc.TileDownloadParams displayTopoTileDownloadDialog(java.io.File tileDir)

  Display a dialog asking the user which SRTM tiles to download.

  Parameters:
    `tileDir` - File pointing at the directory where tiles are kept
  Returns:
    null if the user cancelled the request, or a TileDownloadParams structure containing the needed parameters for the download

### selectFileForWrite

    java.io.File selectFileForWrite(java.io.File dir,
                                    java.lang.String fileExtensionTag,
                                    java.lang.String fileExtension)

  Open a file selection dialog for saving a file.

  Parameters:
    `dir` - File for the initial directory
    `fileExtensionTag` - String tag for looking up localized string of file type description
    `fileExtension` - String file type
  Returns:
    selected File to save the content to, or null if cancelled

### showRawPacketFrame

    void showRawPacketFrame()

  Display the raw packet window.

### showMessageFrame

    void showMessageFrame()

  Open the MessageFrame (window displaying text message traffic in a table) and move it to the foreground. This may be called from any thread (not just the GUI dispatch thread).

### showMessageFilterPane

    void showMessageFilterPane()

  Display the window used for receiving and logging filtered text messages. Intended to support proposed field event logging as described in http://aprs.org/aprsevent.html

### showBulletinBoard

    void showBulletinBoard()

  Display the window used to display bulletin messages, and compose locally originated bulletins for transmission.

### showOutstandingMessages

    void showOutstandingMessages()

  Display the window showing all messages (except beacons and status messages) pending for transmission from the local station.

### showBandwidthMonitor

    void showBandwidthMonitor()

  Display a bandwidth monitor for each open I/O port in YAAC.

### showGpsStatusDialog

    void showGpsStatusDialog()

  Display a monitor of the current status of all GPS receivers connected to YAAC.

### showWeatherDialog

    void showWeatherDialog()

  Display a monitor of the current conditions reported by the local weather station attached to YAAC.

### showHeardList

    void showHeardList()

  Display a report of number of packets received from each station (or about each APRS Object/Item) over 15 minute intervals in the YAAC history.

### showConnectionReport

    void showConnectionReport()

  Display outstanding connected (I-frame) AX.25 sessions.

### showRadioView

    void showRadioView(Message msg,
                       java.lang.String identifier)

  Show the dialog that looks like the Kenwood D710 control head APRS display.

  Parameters:
    `msg` - a historical APRS Message to display, or null to display current real-time data
    `identifier` - the originating station callsign associated with the historical message (ignored if null msg)

### showStationList

    void showStationList()

  Show the window listing all the stations and objects heard by this station.

### showLocalObjects

    void showLocalObjects()

  Display a table of all Objects/Items being transmitted by this station.

### showHistory

    void showHistory(StationState ss)

  Display the message history for a specified station or object.

  Parameters:
    `ss` - StationState of the desired station or object

### showTelemetryReport

    void showTelemetryReport()

  Display all the current telemetry data heard by this station.

### showHealthMonitorReport

    void showHealthMonitorReport()

  Show the current station health reports for all remote stations being monitored.

### showTXIGatedStations

    void showTXIGatedStations()

  Show a table view of the stations currently being Tx I-gated by this station.

### showKeys

    void showKeys()

  Show a table view of the keys used to authenticate and verify the integrity of signed messages.

### showDXReports

    void showDXReports()

  Show a table view of all DX reports received by this station.

### showEditFilterDialog

    void showEditFilterDialog(Filter mainFilter,
                              java.lang.String dialogTitleTag)

  Generate and display the filter dialog.

  Parameters:
    `mainFilter` - the top Filter in the Filter hierarchy
    `dialogTitleTag` - bundle tag for title to display on dialog

### showEditBlacklistDialog

    void showEditBlacklistDialog()

  Generate and display the blacklist editor.

### loadObjectsFromFile

    void loadObjectsFromFile()

  Load APRS Object definitions from a user-specified file.

### saveObjectsToFile

    void saveObjectsToFile()

  Save the currently known APRS Objects to a file.

### loadTacticalNames

    void loadTacticalNames()

  Load alias names and symbol codes for station callsigns and object names.

### saveTacticalNames

    void saveTacticalNames()

  Save alias names and symbol codes for station callsigns and object names.

### loadDrawing

    void loadDrawing()

  Load drawing overlay.

### locateASpecificStation

    void locateASpecificStation(java.util.ArrayList<StationState> matchList,
                                java.lang.String callsign)

  Locate a specific station on the map window.

  Parameters:
    `matchList` - ArrayList of StationStates to locate
    `callsign` - String callsign of the located station

### displayAttentionAlert

    void displayAttentionAlert(StationState ss)

  Display an AttentionAlert (flashing arrows) on the map for a particular station or object.

  Parameters:
    `ss` - StationState of the station or object to highlight

### displayAttentionAlert

    void displayAttentionAlert(double latitude,
                               double longitude,
                               AX25Message.Precedence precedence)

  Display an AttentionAlert (flashing arrows) on the map for a particular position.

  Parameters:
    `latitude` - double fractional degrees North
    `longitude` - double fraction degrees East
    `precedence` - code for color level to use; ROUTINE is used for station locates

### moveObject

    void moveObject(StationState ss,
                    ObjectReport or,
                    MoveObjectListener moveObjectListener)

  Graphically drag a station or object across the map to a new location, updating the object's position appropriately and converting a station to an object if needed.

  Parameters:
    `ss` - StationState object describing the station or object
    `or` - ObjectReport to be modified by the move
    `moveObjectListener` - MoveObjectListener to inform when movement is over

### composeWinlinkMessage

    void composeWinlinkMessage()

  Display a form to allow transmitting a multi-line email message to someone via the APRS-WinLink gateways.

### connectToStation

    void connectToStation()

  Set up a dumb-terminal connection to an old-style packet BBS.

### confirmSendBroadcastQuery

    void confirmSendBroadcastQuery(java.lang.String confirmTag,
                                   java.lang.String query)

  Broadcast a specified global query message after confirming the user really wants to send it.

  Parameters:
    `confirmTag` - tag for resource file message for the confirmation query
    `query` - the actual APRS message to send (must be valid according to the APRS protocol specification)

### approveTacticalSender

    void approveTacticalSender(java.lang.String originatingCallsign,
                               java.lang.String tacticalMsgText)

  Queue up a request to ask the user whether this TACTICAL message should be accepted and processed. This is expected to be called from a background thread, so the implementor is required to move it to the GUI dispatch thread.

  Parameters:
    `originatingCallsign` - callsign String of message originator
    `tacticalMsgText` - String of text message body (the TACTICAL directive)

### sendQRU

    void sendQRU()

  Broadcast a specified QRU query message after confirming the user really wants to send it. and asking which QRU category to ask for.

### showRasterMapDialog

    void showRasterMapDialog()

  Display the dialog for managing raster map images overlays on the map window.

### invokeObjectEditor

    void invokeObjectEditor(java.lang.String dialogTitleTag,
                            Message or,
                            int mouseX,
                            int mouseY,
                            ObjectReportTransmitter tx)

  Display the Object editing dialog, possibly initialized with the contents of an existing ObjectReport.

  Parameters:
    `dialogTitleTag` - String tag for localized title to display on dialog title bar
    `or` - APRS Message to initialize the editor, or null for creating an object from scratch
    `mouseX` - window X coordinate of mouse click (to generate initial coordinates), or -1 to not init position from map
    `mouseY` - window Y coordinate of mouse click (to generate initial coordinates), or -1 to not init position from map
    `tx` - ObjectReportTransmitter to give any created or updated objects to

### showIOFailureDialog

    void showIOFailureDialog(PortConfig config,
                             java.lang.String reason,
                             PortFailureReportListener listener)

  Display an asynchronous non-blocking dialog on the screen to report an I/O error. This method should only be called from background threads (such as port I/O handling threads), and not from the AWT dispatch thread.

  Parameters:
    `config` - PortConfig object describing the port with the problem
    `reason` - String describing why the port is down
    `listener` - I/O subsystem that wants to be informed if the user dismisses the dialog

### closeCurrentWindow

    void closeCurrentWindow()

  Close the window that currently has the keyboard focus (if it is part of the YAAC application).

### pickAStation

    StationState pickAStation(java.util.ArrayList<StationState> matchList,
                              java.lang.String titleTag)

  Select one of several stations.

  Parameters:
    `matchList` - ArrayList of StationState objects to pick from
    `titleTag` - String name of resource tag for title of prompting dialog
  Returns:
    selected StationState, or null if the user cancelled

### scheduleToGuiThread

    void scheduleToGuiThread(java.lang.Runnable r)

  Schedule a short-running operation that should only occur on the GUI dispatch thread (however the implementing GUI chooses to do it).

  Parameters:
    `r` - Runnable to be scheduled as soon as possible on the GUI thread

### refresh

    void refresh()

  Force the map to immediately regenerate itself based on current state data.

### regenerateTopo

    void regenerateTopo()

  Force the topographic layer to regenerate its overlay immediately.

### regenerateStations

    void regenerateStations()

  Force the station renderer layer to regenerate its overlay immediately.

### isViewPrintable

    boolean isViewPrintable(java.lang.Object o,
                            int depthLeft)

  Test if specified GUI view is printable.

  Parameters:
    `o` - Object of view container
    `depthLeft` - number of levels of recursion allowed for the search
  Returns:
    boolean true if view is printable
  See Also:
    `printWindow()`

### printWindow

    void printWindow()

  Print the window that currently has the focus.

  See Also:
    `isViewPrintable(Object, int)`

### toFront

    void toFront()

  Push the map GUI window to the foreground by whatever means the underlying GUI toolkit uses.

### setMemoryGCPanelVisible

    void setMemoryGCPanelVisible(boolean visible)

  Change the visibility of the memory usage status monitor.

  Parameters:
    `visible` - boolean true if memory status monitor should be visible

### isMemoryGCPanelVisible

    boolean isMemoryGCPanelVisible()

  Report the current visibility of the MemoryGCPanel.

  Returns:
    boolean true if panel is visible

### displayHeardByDialog

    java.lang.Object[] displayHeardByDialog(StationState[] stationsToPickFrom)

  Display a dialog asking for the parameters for a Heard-By (?APRSH) query.

  Parameters:
    `stationsToPickFrom` - array of StationState objects specifying the list of stations to choose from, or null to get all currently known stations
  Returns:
    null if the query was cancelled, or a two-element array specifying the station to query and the station that the queried station might have heard

### displayMessagingDialog

    GuiIfc.MessagingParams displayMessagingDialog(java.util.ArrayList ssList)

  Display a dialog asking the user for the parameters needed to send a text message to another station.

  Parameters:
    `ssList` - list of stations to populate the list with, or null for entire list of known stations
  Returns:
    null if the user cancelled the request, or a MessagingParams structure containing the parameters

### displayLocateLandmarkDialog

    void displayLocateLandmarkDialog()

  Display the Locate Landmark dialog, and handle user input to it.

### displayLocateAmenityDialog

    void displayLocateAmenityDialog()

  Display the Locate Amenity dialog, and handle user input to it.

### startChatSession

    void startChatSession(java.lang.String callsign)

  Open a Chat session window pointed at the specified remote station.

  Parameters:
    `callsign` - String callsign of the remote station

### isDrawAllTrackStripes

    boolean isDrawAllTrackStripes()

  Indicate whether all moving stations should have track stripes plotted.

  Returns:
    boolean true if all moving stations should have track stripes

### setDrawAllTrackStripes

    void setDrawAllTrackStripes(boolean drawAllTrackStripes)

  Specify whether all moving stations should have track stripes plotted.

  Parameters:
    `drawAllTrackStripes` - boolean true if all moving stations should have track stripes

### clearAllSpecificTrackStripes

    void clearAllSpecificTrackStripes()

  Clear the plotting of all specific station/object track stripes.

### addSpecificTrackStripe

    void addSpecificTrackStripe(java.lang.String identifier)

  Add the identifier of a single station or object whose track stripe is to be plotted.

  Parameters:
    `identifier` - String station or object identifier

### removeSpecificTrackStripe

    boolean removeSpecificTrackStripe(java.lang.String identifier)

  Remove the identifier of a single station or object whose track stripe is no longer to be plotted.

  Parameters:
    `identifier` - String station or object identifier
  Returns:
    boolean true if identifier was removed

### isSpecificallyTracked

    boolean isSpecificallyTracked(java.lang.String identifier)

  Test if a given identifier is on the tracking list.

  Parameters:
    `identifier` - String station or object identifier
  Returns:
    boolean true if this identifier is marked for track stripe display

### isSpecificallyTracking

    boolean isSpecificallyTracking()

  Test if any identifiers are on the tracking list.

  Returns:
    boolean true if any stations are specifically tagged for tracking

### getMaxTrackDuration

    long getMaxTrackDuration()

  Get the maximum duration of a track stripe in milliseconds.

  Returns:
    maximum plotted track duration in milliseconds

### setMaxTrackDuration

    void setMaxTrackDuration(long maxTrackDuration)

  Set the maximum duration of a track stripe in milliseconds.

  Parameters:
    `maxTrackDuration` - maximum plotted track duration in milliseconds

### isDrawRangeCircles

    boolean isDrawRangeCircles()

  Report whether radio range circles are being drawn for stations reporting or implying transmission range limits.

  Returns:
    boolean true if range circles are being drawn

### setDrawRangeCircles

    void setDrawRangeCircles(boolean drawRangeCircles)

  Specify whether range circles should be drawn around stations reporting or implying transmission range limits.

  Parameters:
    `drawRangeCircles` - boolean true if range circles should be drawn

### isDrawMicEStatusCircles

    boolean isDrawMicEStatusCircles()

  Report whether color-coded circles indicating Mic-E status codes are be drawn around stations reporting those codes.

  Returns:
    boolean true if Mic-E status color circles are drawn

### setDrawMicEStatusCircles

    void setDrawMicEStatusCircles(boolean drawMicEStatusCircles)

  Specify whether color-coded circles indicating Mic-E status codes should be drawn around stations reporting those codes.

  Parameters:
    `drawMicEStatusCircles` - boolean true if Mic-E status color circles should be drawn

### isDrawSelf

    boolean isDrawSelf()

  Report whether the local station is plotted on the map.

  Returns:
    boolean true if local station is drawn

### setDrawSelf

    void setDrawSelf(boolean drawSelf)

  Specify whether the local station should be plotted on the map.

  Parameters:
    `drawSelf` - boolean true if local station should be drawn

### isDrawSelfLikeOther

    boolean isDrawSelfLikeOther()

  Report whether local station is drawn like any other station (using its APRS symbol icon) or as crosshairs or a pointer making it obvious where the station is on the map.

  Returns:
    boolean true to use APRS symbol, or false to use crosshairs for fixed station or pointer arrowhead for moving station
  See Also:
    `isDrawSelf()`

### setDrawSelfLikeOther

    void setDrawSelfLikeOther(boolean drawSelfLikeOther)

  Specify whether local station should be drawn like any other station (using its APRS symbol icon) or as crosshairs or a pointer making it obvious where the station is on the map.

  Parameters:
    `drawSelfLikeOther` - boolean true to use APRS symbol, or false to use crosshairs for fixed station or pointer arrowhead for moving station
  See Also:
    `setDrawSelf(boolean)`

### isDrawWeatherAsWeather

    boolean isDrawWeatherAsWeather()

  Report whether weather stations are drawn as old-style weather map circles with a flagged barb indicating wind direction and speed.

  Returns:
    boolean true if weather stations should be plotted with weather map symbols, false if using APRS icon

### setDrawWeatherAsWeather

    void setDrawWeatherAsWeather(boolean drawWeatherAsWeather)

  Specify whether weather stations should be drawn as old-style weather map circles with a flagged barb indicating wind direction and speed.

  Parameters:
    `drawWeatherAsWeather` - boolean true if weather stations should be plotted with weather map symbols, false if using APRS icon

### isDrawAge

    boolean isDrawAge()

  Report whether the time interval since last receipt of a message from or about a station or object is plotted below the station/object's name.

  Returns:
    boolean true if age is to be plotted

### setDrawAge

    void setDrawAge(boolean drawAge)

  Specify whether the time interval since last receipt of a message from or about a station or object should be plotted below the station/object's name.

  Parameters:
    `drawAge` - boolean true if age is to be plotted

### isDrawDeadObjects

    boolean isDrawDeadObjects()

  Report whether Objects that have been "killed" are plotted on the map.

  Returns:
    boolean true if "killed" Objects are plotted

### setDrawDeadObjects

    void setDrawDeadObjects(boolean drawDeadObjects)

  Specify whether Objects that have been "killed" should still be plotted on the map.

  Parameters:
    `drawDeadObjects` - boolean true if "killed" Objects should be plotted

### isDrawAlohaCircle

    boolean isDrawAlohaCircle()

  Report whether aloha circles (optimal maximum RF transmission range for the local station before causing excessive collisions) are plotted on the map.

  Returns:
    boolean true if aloha circles are drawn

### setDrawAlohaCircle

    void setDrawAlohaCircle(boolean drawAlohaCircle)

  Specify whether aloha circles (optimal maximum RF transmission range for the local station before causing excessive collisions) should be plotted on the map. Note these will only appear if the local station has RF ports that can have collisions.

  Parameters:
    `drawAlohaCircle` - boolean true if aloha circles should be drawn

### isDrawItemStatus

    boolean isDrawItemStatus()

  Report whether a color-coded "halo" is drawn around each station or object icon indicating its status as one of the APRSdos categories: fixed, mobile, deadreckoned, old, emergency-reporting, locally-controlled Object, or other station's Object.

  Returns:
    boolean true if status halo is drawm
  See Also:
    `StationState.SpecialState`

### setDrawItemStatus

    void setDrawItemStatus(boolean drawItemStatus)

  Specify whether a color-coded "halo" should be drawn around each station or object icon indicating its status as one of the APRSdos categories: fixed, mobile, deadreckoned, old, emergency-reporting, locally-controlled Object, or other station's Object.

  Parameters:
    `drawItemStatus` - boolean true if status halo should be drawm
  See Also:
    `StationState.SpecialState`

### isDrawAmbiguityCircle

    boolean isDrawAmbiguityCircle()

  Report whether a translucent ambiguity circle is drawn behind each station or object to indicate the area over which it could be located, given the precision of the position information reported.

  Returns:
    boolean true if ambiguity circles are plotted

### setDrawAmbiguityCircle

    void setDrawAmbiguityCircle(boolean drawAmbiguityCircle)

  Specify whether a translucent ambiguity circle should be drawn behind each station or object to indicate the area over which it could be located, given the precision of the position information reported.

  Parameters:
    `drawAmbiguityCircle` - boolean true if ambiguity circles should be plotted

### isDrawDeadReckoning

    boolean isDrawDeadReckoning()

  Report whether deadreckoning position updates for moving stations and objects are calculated and the positions offset and deadreckoning vectors plotted when the stations and objecfts are drawn.

  Returns:
    boolean true if deadreckoning is plotted

### setDrawDeadReckoning

    void setDrawDeadReckoning(boolean drawDeadReckoning)

  Specify whether deadreckoning position updates for moving stations and objects should be calculated and the positions offset and deadreckoning vectors plotted when the stations and objecfts are drawn.

  Parameters:
    `drawDeadReckoning` - boolean true if deadreckoning should be plotted

### getMaxAgeDRStation

    long getMaxAgeDRStation()

  Get the maximum time that dead reckoning will be projected for a station (self-transmitter).

  Returns:
    maximum dead reckon interval in milliseconds

### setMaxAgeDRStation

    void setMaxAgeDRStation(long maxAgeDRStation)

  Set the maximum time that dead reckoning will be projected for a station (self-transmitter).

  Parameters:
    `maxAgeDRStation` - maximum dead reckon interval in milliseconds

### getMaxAgeDRObject

    long getMaxAgeDRObject()

  Get the maximum time that dead reckoning will be projected for an object (non-self-transmitter).

  Returns:
    maximum dead reckon interval in milliseconds

### setMaxAgeDRObject

    void setMaxAgeDRObject(long maxAgeDRObject)

  Set the maximum time that dead reckoning will be projected for an object (non-self-transmitter).

  Parameters:
    `maxAgeDRObject` - maximum dead reckon interval in milliseconds

### getMaxAgeDRSpecialObject

    long getMaxAgeDRSpecialObject()

### setMaxAgeDRSpecialObject

    void setMaxAgeDRSpecialObject(long maxAgeDRSpecialObject)

### isDrawDF

    boolean isDrawDF()

  Report whether direction-finding cones are plotted from stations reporting DFS vector information

  Returns:
    boolean true if direction-finding cones are drawm

### setDrawDF

    void setDrawDF(boolean drawDF)

  Specify whether direction-finding cones should be plotted from stations reporting DFS vector information

  Parameters:
    `drawDF` - boolean true if direction-finding cones should be drawm

### isDrawNWSMultiLine

    boolean isDrawNWSMultiLine()

  Report whether encoded polylines (generally used for National Weather Service severe weather regions) are plotted on the map.

  Returns:
    boolean true if multilines are plotted

### setDrawNWSMultiLine

    void setDrawNWSMultiLine(boolean drawNWSMultiLine)

  Specify whether encoded polylines (generally used for National Weather Service severe weather regions) should be plotted on the map.

  Parameters:
    `drawNWSMultiLine` - boolean true if multilines should be plotted

### isDrawCallsign

    boolean isDrawCallsign()

  Report whether callsign label should be drawn for each station/object.

  Returns:
    boolean true if callsign label should be drawn on map

### setDrawCallsign

    void setDrawCallsign(boolean drawCallsign)

  Specify whether callsign labels should be drawn for each station/object.

  Parameters:
    `drawCallsign` - boolean true if callsign label should be drawn on map

### isDrawAliasInsteadOfCallsign

    boolean isDrawAliasInsteadOfCallsign()

  Report whether alias should be drawn instead of callsign should be drawn for each station/object if an alias is defined for the station/object..

  Returns:
    boolean true if alias should be drawn instead of callsign

### setDrawAliasInsteadOfCallsign

    void setDrawAliasInsteadOfCallsign(boolean drawAliasInsteadOfCallsign)

  Specify whether alias should be drawn instead of callsign should be drawn for each station/object if an alias is defined for the station/object..

  Parameters:
    `drawAliasInsteadOfCallsign` - boolean true if alias should be drawn instead of callsign

### isKeepSpecificallyTrackedStationsOnScreen

    boolean isKeepSpecificallyTrackedStationsOnScreen()

  Report whether the map should auto-pan to keep specifically tracked mobile stations on the map.

  Returns:
    boolean true if map should pan to keep tracked stations on the map

### setKeepSpecificallyTrackedStationsOnScreen

    void setKeepSpecificallyTrackedStationsOnScreen(boolean keepSpecificallyTrackedStationsOnScreen)

  Specify whether the map should auto-pan to keep specifically tracked mobile stations on the map.

  Parameters:
    `keepSpecificallyTrackedStationsOnScreen` - boolean true if map should pan to keep tracked stations on the map

### isDrawDoubleSizedSymbols

    boolean isDrawDoubleSizedSymbols()

  Report if symbols are being drawn double-sized.

  Returns:
    boolean true if symbols are rendered double-size

### setDrawDoubleSizedSymbols

    void setDrawDoubleSizedSymbols(boolean drawDoubleSizedSymbols)

  Specify whether symbols should be drawn double-sized (32x32 pixels) instead of single-sized (16x16).

  Parameters:
    `drawDoubleSizedSymbols` - boolean true if symbols should be rendered double-size

### setDrawToolBarVisibility

    void setDrawToolBarVisibility(boolean isVisible)

  Specify whether the toolbar for the drawing tools should be visible or not.

  Parameters:
    `isVisible` - boolean true if draw toolbar should be shown

### isGraticuleVisible

    boolean isGraticuleVisible()

  Indicate whether the graticule (latitude/longitude grid lines) are displayed on the map.

  Returns:
    boolean true if graticule is displayed

### setGraticuleVisible

    void setGraticuleVisible(boolean visible)

  Specify whether the graticule (latitude/longitude grid lines) are displayed on the map.

  Parameters:
    `visible` - boolean true if graticule is displayed

### isShowTopoRegions

    boolean isShowTopoRegions()

  Report whether the topographic map overlay should be displayed as filled regions.

  Returns:
    boolean true if topographic overlay is displayed

### setShowTopoRegions

    void setShowTopoRegions(boolean visible)

  Specify whether the topographic map overlay should be rendered as filled region. Note this is independent of whether there actually is any topographic data to render.

  Parameters:
    `visible` - boolean true if topographic layer should be rendered as regions

### isShowTopoContours

    boolean isShowTopoContours()

  Report whether the topographic map should be rendered as contour lines.

  Returns:
    boolean true if topography should be rendered as contour lines

### setShowTopoContours

    void setShowTopoContours(boolean visible)

  Specify whether the topographic map overlay should be rendered as contour lines. Note this is independent of whether there actually is any topographic data to render.

  Parameters:
    `visible` - boolean true if topographic layer should be rendered as contour lines

### editTopoColors

    void editTopoColors()

  Invoke an editor for adjusting the colors and elevation thresholds used to render topographic map layers.

### isShowUnlabeledWays

    boolean isShowUnlabeledWays()

  Report if unlabeled and untyped map features should be displayed.

  Returns:
    boolean true if unlabeled/untyped map elements should be plotted

### setShowUnlabeledWays

    void setShowUnlabeledWays(boolean showUnlabeledWays)

  Specify if unlabeled and untyped map features should be displayed.

  Parameters:
    `showUnlabeledWays` - boolean true if unlabeled/untyped map elements should be plotted

### isShowLabelsInEnglish

    boolean isShowLabelsInEnglish()

  Report whether map labels should be displayed in English if the default name is in some other locale and OpenStreetMap provides an English translation.

  Returns:
    boolean true if English labels should be used

### setShowLabelsInEnglish

    void setShowLabelsInEnglish(boolean showLabelsInEnglish)

  Specify whether map labels should be displayed in English if the default name is in some other locale and OpenStreetMap provides an English translation.

  Parameters:
    `showLabelsInEnglish` - boolean true if English labels should be used

### isAutoLoadMapTiles

    boolean isAutoLoadMapTiles()

  Report whether map tiles will be auto-downloaded (if the author's website can be reached) for any tiles that have not already been downloaded.

  Returns:
    boolean true if auto-download is enabled

### setAutoLoadMapTiles

    void setAutoLoadMapTiles(boolean autoLoadMapTiles)

  Specify whether missing OpenStreetMap imported tiles should be automatically downloaded from the author's website.

  Parameters:
    `autoLoadMapTiles` - boolean true to enable auto-download

### startLineOfSight

    void startLineOfSight()

  Enable defining a line of sight between two points on the map.

### startLineOfSightFromMe

    void startLineOfSightFromMe(int mouseX,
                                int mouseY)

  Show the line of sight between this station's position and the position clicked on the map, updating this station's end of the line if it moves.

  Parameters:
    `mouseX` - int horizontal pixel coordinate in map
    `mouseY` - int vertical pixel coordinate in map

### startLineOfSightFromMe

    void startLineOfSightFromMe(StationState ss)

  Show the line of sight between this station's position and the station or object clicked on the map, updating both ends of the line if either moves.

  Parameters:
    `ss` - StationState of station or object to trace the path to

### displayHelp

    void displayHelp(java.lang.String startingHelpId,
                     java.lang.Object parentWindow)

  Launch the JavaHelp browser, starting with the help corresponding to the specified help ID

  Parameters:
    `startingHelpId` - String help ID corresponding to an entry in a *.jhm file; null indicates the top of the TOC view, empty string indicates the top of the Index view
    `parentWindow` - window to parent an incarnation of the HelpBroker

### checkForUpdates

    void checkForUpdates(boolean interactive)

  Check whether a newer release of YAAC is available, displaying status.

  Parameters:
    `interactive` - boolean true if no-upgrade-needed status should be reported (out-of-date status is always reported)

### showPluginStore

    void showPluginStore()

  Display a dialog for selecting new officially supported plugins to install.

### getLastElapsedPaintTime

    long getLastElapsedPaintTime()

  Return the amount of time (in milliseconds) for the last station render.

  Returns:
    elapsed time in milliseconds for last StationRenderer run

### getLastNumDrawnObjects

    int getLastNumDrawnObjects()

  Return the number of Objects (non-transmitters) rendered in the last station render.

  Returns:
    count of rendered Objects

### getLastNumDrawnStations

    int getLastNumDrawnStations()

  Return the number of stations (transmitters) rendered in the last station render.

  Returns:
    count of rendered stations

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD